<?php

namespace ServiceType;

use \WsdlToPhp\PackageBase\AbstractSoapClientBase;

/**
 * This class stands for Cancelar ServiceType
 * @subpackage Services
 */
class Cancelar extends AbstractSoapClientBase
{
    /**
     * Method to call the operation originally named CancelarCFDI2022
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\CancelarCFDI2022 $parameters
     * @return \StructType\CancelarCFDI2022Response|bool
     */
    public function CancelarCFDI2022(\StructType\CancelarCFDI2022 $parameters)
    {
        try {
            $this->setResult($this->getSoapClient()->CancelarCFDI2022($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named CancelarCFDI
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\CancelarCFDI $parameters
     * @return \StructType\CancelarCFDIResponse|bool
     */
    public function CancelarCFDI(\StructType\CancelarCFDI $parameters)
    {
        try {
            $this->setResult($this->getSoapClient()->CancelarCFDI($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named CancelarCFDICA
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\CancelarCFDICA $parameters
     * @return \StructType\CancelarCFDICAResponse|bool
     */
    public function CancelarCFDICA(\StructType\CancelarCFDICA $parameters)
    {
        try {
            $this->setResult($this->getSoapClient()->CancelarCFDICA($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named CancelarCFDICA2022
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\CancelarCFDICA2022 $parameters
     * @return \StructType\CancelarCFDICA2022Response|bool
     */
    public function CancelarCFDICA2022(\StructType\CancelarCFDICA2022 $parameters)
    {
        try {
            $this->setResult($this->getSoapClient()->CancelarCFDICA2022($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Returns the result
     * @see AbstractSoapClientBase::getResult()
     * @return \StructType\CancelarCFDI2022Response|\StructType\CancelarCFDICA2022Response|\StructType\CancelarCFDICAResponse|\StructType\CancelarCFDIResponse
     */
    public function getResult()
    {
        return parent::getResult();
    }
}
